Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/PushProgram.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/PushProgram.cs	(revision 14744)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/PushProgram.cs	(revision 14745)
@@ -1,9 +1,13 @@
-﻿using System.Collections.Generic;
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
 
 namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
   using System.Diagnostics;
-  using System.Linq;
-
-  public class PushProgram {
+
+  using Interpreter;
+
+  public class PushProgram : StatefulExpression<Expression[]> {
+    public static readonly PushProgram Empty = new PushProgram();
 
     private const string Prefix = "(";
@@ -13,16 +17,16 @@
     private const string Delimiter = " ";
 
-    public static readonly PushProgram Empty = new PushProgram(new Expression[0]);
-
-    public readonly IReadOnlyList<Expression> Expressions;
-    public bool IsEmpty { get; private set; }
-
-    public PushProgram(Expression[] expressions) {
-      this.Expressions = expressions;
-      this.IsEmpty = expressions.Length == 0;
+    public readonly bool IsEmpty;
+
+    public PushProgram(params Expression[] state) : base(state) {
+      IsEmpty = state.Length == 0;
+    }
+
+    public PushProgram(IEnumerable<Expression> state) : this(state.ToArray()) {
+      // TODO: lazy evaluation of ToArray()
     }
 
     private string stringRepresentation;
-    private string StringRepresentation
+    public override string StringRepresentation
     {
       get
@@ -35,5 +39,5 @@
 
     private int depth = -1;
-    private int Depth
+    public int Depth
     {
       get
@@ -44,10 +48,10 @@
     }
 
-    private int[] treeIndex = null;
-    public int[] TreeIndex
-    {
-      get
-      {
-        return this.treeIndex ?? (this.treeIndex = this.BuildTreeIndex());
+    private int[] treeIndex;
+    private int[] TreeIndex
+    {
+      get
+      {
+        return treeIndex ?? (treeIndex = BuildTreeIndex());
       }
     }
@@ -61,4 +65,16 @@
         return hashCode;
       }
+    }
+
+    //public PushProgram Copy() {
+    //  // as the empty list is a static stateless expression, no copy required
+    //  return ReferenceEquals(this, Empty) || this.State.IsEmpty
+    //    ? Empty
+    //    : new PushProgram(this.State.Copy());
+    //}
+
+    public override bool Eval(IPushInterpreter interpreter) {
+      interpreter.ExecStack.Push(this.State);
+      return true;
     }
 
@@ -87,9 +103,9 @@
 
     public IEnumerable<Expression> DepthFirst() {
-      foreach (var expr in this.Expressions) {
+      foreach (var expr in this.State) {
         if (expr.CanExpand) {
-          var expandExpr = (ExecExpandExpression)expr;
-
-          foreach (var sub in expandExpr.State.DepthFirst())
+          var expandExpr = (PushProgram)expr;
+
+          foreach (var sub in expandExpr.DepthFirst())
             yield return sub;
         } else yield return expr;
@@ -98,5 +114,5 @@
 
     public PushProgram Copy() {
-      return IsEmpty ? this : new PushProgram((Expression[])Expressions) {
+      return IsEmpty ? this : new PushProgram(State) {
         stringRepresentation = this.stringRepresentation,
         hashCode = this.hashCode,
@@ -106,7 +122,10 @@
     }
 
-    public Expression[] CopyExpressions() {
-      var copy = new Expression[this.Expressions.Count];
-      ((Expression[])this.Expressions).CopyTo(copy, Expressions.Count);
+    public Expression[] CopyExpressions()
+    {
+      if (IsEmpty) return Empty.State;
+
+      var copy = new Expression[State.Length];
+      State.CopyTo(copy, 0);
 
       return copy;
@@ -114,19 +133,12 @@
 
     private int CalcDepth() {
-      //var subExpressions = Expressions.Where(e => e.CanExpand);
-      //var depth = subExpressions.Any()
-      //    ? subExpressions.Select(e => e as ExecExpandExpression).Max(e => e.State.Depth) + 1
-      //    : 1;
-
-      ////return depth;
-
       var maxDepth = 1;
-      for (var i = 0; i < Expressions.Count; i++) {
-        var expression = Expressions[i];
+      for (var i = 0; i < State.Length; i++) {
+        var expression = State[i];
         if (!expression.CanExpand) continue;
-        var expandExpression = (ExecExpandExpression)expression;
-
-        if (expandExpression.State.Depth > maxDepth)
-          maxDepth = expandExpression.State.Depth;
+        var expandExpression = (PushProgram)expression;
+
+        if (expandExpression.Depth > maxDepth)
+          maxDepth = expandExpression.Depth;
       }
 
@@ -137,20 +149,20 @@
       // prevent too big string
       return this.TotalCount > 50
-        ? PrefixReduced + this.Expressions.Count + PostfixReduced
-        : Prefix + string.Join(Delimiter, this.Expressions.Where(e => !string.IsNullOrWhiteSpace(e.StringRepresentation))) + Postfix;
+        ? PrefixReduced + this.State.Length + PostfixReduced
+        : Prefix + string.Join(Delimiter, this.State.Where(e => !string.IsNullOrWhiteSpace(e.StringRepresentation))) + Postfix;
     }
 
     private int[] BuildTreeIndex() {
-      var local_treeIndex = new int[this.Expressions.Count];
+      var local_treeIndex = new int[State.Length];
 
       var next = 1;
 
-      for (var i = this.Expressions.Count - 1; i >= 0; i--) {
-        var subExpression = this.Expressions[i];
+      for (var i = State.Length - 1; i >= 0; i--) {
+        var subExpression = State[i];
 
         local_treeIndex[i] = next;
 
         if (subExpression.CanExpand) {
-          next += ((ExecExpandExpression)subExpression).State.TotalCount;
+          next += ((PushProgram)subExpression).TotalCount;
         } else {
           next++;
@@ -164,6 +176,6 @@
       var hash = 19 * 31 + this.GetType().FullName.GetHashCode();
 
-      for (var i = 0; i < this.Expressions.Count; i++) {
-        hash = hash * 31 + this.Expressions[i].GetHashCode();
+      for (var i = 0; i < State.Length; i++) {
+        hash = hash * 31 + State[i].GetHashCode();
       }
 
@@ -171,6 +183,6 @@
     }
 
-    private static void CheckIfNested(int level, ExecExpandExpression target, ExecExpandExpression current,
-        IList<ExecExpandExpression> visited) {
+    private static void CheckIfNested(int level, PushProgram target, PushProgram current,
+        IList<PushProgram> visited) {
       if (visited.Any(x => ReferenceEquals(x, current)))
         Debugger.Break();
@@ -183,9 +195,9 @@
       }
 
-      for (var i = 0; i < current.State.Expressions.Count; i++) {
-        if (current.State.Expressions[i].CanExpand)
+      for (var i = 0; i < current.State.Length; i++) {
+        if (current.State[i].CanExpand)
           continue;
 
-        var subExpression = current.State.Expressions[i] as ExecExpandExpression;
+        var subExpression = current.State[i] as PushProgram;
 
         if (ReferenceEquals(target, subExpression)) {
@@ -199,4 +211,40 @@
       visited.RemoveAt(visited.Count - 1);
     }
+
+    /// <summary>
+    ///     Returns the element with the given index whereby the tree is indexed in depth first manner
+    /// </summary>
+    /// <param name="index">The index of the required element</param>
+    /// <returns>The required element</returns>
+    public Expression GetFromTree(int index) {
+      return GetFromTree(index, (root, parent, child, childIndex, parentIndex) => child);
+    }
+
+    /// <returns>The required element</returns>
+    public T GetFromTree<T>(int index,
+        Func<PushProgram, PushProgram, Expression, int, int, T> resolver) {
+      return GetFromTree(index, 0, null, resolver);
+    }
+
+    private T GetFromTree<T>(int index, int parentIndex, PushProgram parent,
+        Func<PushProgram, PushProgram, Expression, int, int, T> resolver) {
+      if (index == 0) return resolver(parent, parent, this, 0, parentIndex);
+
+      var min = State.Length - 1;
+      var max = 0;
+      var mid = (min + max) / 2;
+
+      while ((max <= min) && (TreeIndex[mid] != index)) {
+        if (TreeIndex[mid] > index) max = mid + 1;
+        else min = mid - 1;
+
+        mid = (min + max) / 2;
+      }
+
+      return TreeIndex[mid] == index
+          ? resolver(parent, this, State[mid], mid, parentIndex)
+          : (State[mid + 1] as PushProgram).GetFromTree(index - TreeIndex[mid + 1], mid + 1,
+              this, resolver);
+    }
   }
 }
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/StatefulExpression.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/StatefulExpression.cs	(revision 14744)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/StatefulExpression.cs	(revision 14745)
@@ -1,7 +1,4 @@
 ﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Data.Pool;
-
-  public abstract class StatefulExpression<T> : Expression
-  {
+  public abstract class StatefulExpression<T> : Expression {
     public readonly T State;
 
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Generators/CodeGenerator.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Generators/CodeGenerator.cs	(revision 14744)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Generators/CodeGenerator.cs	(revision 14745)
@@ -24,8 +24,8 @@
     }
 
-    public static ExecExpandExpression RandomExpandExpression(int maxPoints, IRandom random = null, IReadonlyPushConfiguration pushGpConfiguration = null, IDictionary<string, Expression> customExpressions = null) {
+    public static PushProgram RandomExpandExpression(int maxPoints, IRandom random = null, IReadonlyPushConfiguration pushGpConfiguration = null, IDictionary<string, Expression> customExpressions = null) {
       var program = RandomProgram(maxPoints, random, pushGpConfiguration, customExpressions);
 
-      return new ExecExpandExpression(program);
+      return new PushProgram(program);
     }
 
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Interpreter/IPushInterpreter.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Interpreter/IPushInterpreter.cs	(revision 14744)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Interpreter/IPushInterpreter.cs	(revision 14745)
@@ -28,8 +28,8 @@
     void Clear();
     void Run(string code, bool stepwise = false);
-    void Run(Expression program, bool stepwise = false);
-    void Run(PushProgram program, bool stepwise = false);
-    Task RunAsync(PushProgram program, bool paused = false, CancellationToken token = default(CancellationToken));
-    Task RunAsync(Expression program, bool paused = false, CancellationToken token = default(CancellationToken));
+    void Run(Expression expression, bool stepwise = false);
+    //void Run(PushProgram program, bool stepwise = false);
+    //Task RunAsync(PushProgram program, bool paused = false, CancellationToken token = default(CancellationToken));
+    Task RunAsync(Expression expression, bool paused = false, CancellationToken token = default(CancellationToken));
     Task RunAsync(string code, bool paused = false, CancellationToken token = default(CancellationToken));
     Task AbortAndResetAsync();
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Interpreter/PushInterpreter.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Interpreter/PushInterpreter.cs	(revision 14744)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Interpreter/PushInterpreter.cs	(revision 14745)
@@ -7,5 +7,4 @@
   using HeuristicLab.Core;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Configuration;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Data.Pool;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Expressions;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Parser;
@@ -101,4 +100,18 @@
     public bool IsNameQuoteFlagSet { get; set; }
 
+    public Task RunAsync(string code, bool stepwise = false, CancellationToken token = default(CancellationToken)) {
+      var program = PushParser.Parse(code);
+
+      currentTask = RunAsync(program, stepwise, token);
+
+      return currentTask;
+    }
+    public async Task RunAsync(
+      Expression expression,
+      bool stepwise = false,
+      CancellationToken token = default(CancellationToken)) {
+      await Task.Run(() => Run(expression, stepwise), token);
+    }
+
     public void Run(string code, bool stepwise = false) {
       var program = PushParser.Parse(code);
@@ -106,33 +119,4 @@
     }
 
-    public Task RunAsync(string code, bool stepwise = false, CancellationToken token = default(CancellationToken)) {
-      var program = PushParser.Parse(code);
-
-      currentTask = RunAsync(program, stepwise, token);
-
-      return currentTask;
-    }
-
-    public async Task RunAsync(
-      PushProgram program,
-      bool stepwise = false,
-      CancellationToken token = default(CancellationToken)) {
-      var expression = new ExecExpandExpression(program);
-
-      await RunAsync(expression, stepwise, token);
-    }
-
-    public async Task RunAsync(
-      Expression program,
-      bool stepwise = false,
-      CancellationToken token = default(CancellationToken)) {
-      await Task.Run(() => Run(program, stepwise), token);
-    }
-
-    public void Run(PushProgram program, bool stepwise = false) {
-      var expression = new ExecExpandExpression(program);
-
-      Run(expression, stepwise);
-    }
 
     public void Run(Expression program, bool stepwise = false) {
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Parser/PushParser.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Parser/PushParser.cs	(revision 14744)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Parser/PushParser.cs	(revision 14745)
@@ -16,5 +16,5 @@
     private static readonly char[] symbolTrim = { '\r', '\n' };
 
-    public static Expression Parse(string source, int startIndex = 0) {
+    public static PushProgram Parse(string source, int startIndex = 0) {
       var symbols = source.Split(delimiter);
 
@@ -23,5 +23,5 @@
     }
 
-    private static Expression Parse(string[] symbols, int startIndex, out int endIndex) {
+    private static PushProgram Parse(string[] symbols, int startIndex, out int endIndex) {
       var expressions = new List<Expression>();
 
@@ -39,5 +39,5 @@
           case closeBrace:
             endIndex = i;
-            return new ExecExpandExpression(expressions.ToArray());
+            return new PushProgram(expressions.ToArray());
         }
 
@@ -62,7 +62,5 @@
       endIndex = symbols.Length - 1;
 
-      return expressions.Count == 1
-        ? expressions[0]
-        : new ExecExpandExpression(expressions.ToArray());
+      return new PushProgram(expressions.ToArray());
     }
 
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/PushProblem.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/PushProblem.cs	(revision 14744)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/PushProblem.cs	(revision 14745)
@@ -406,5 +406,5 @@
 
       var program = individual.PushProgram(config.EnabledExpressions as IReadOnlyList<string>);
-      var expandExpression = new ExecExpandExpression(program);
+      var expandExpression = new PushProgram(program);
       var results = new List<double>();
 
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Simplifier/ISimplifier.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Simplifier/ISimplifier.cs	(revision 14744)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Simplifier/ISimplifier.cs	(revision 14745)
@@ -6,5 +6,5 @@
 
   public interface ISimplifier {
-    ExecExpandExpression Simplify(ExecExpandExpression program, IRandom random, Predicate<ExecExpandExpression> isBetter);
+    PushProgram Simplify(PushProgram program, IRandom random, Predicate<PushProgram> isBetter);
   }
 }
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Simplifier/RandomSimplifier.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Simplifier/RandomSimplifier.cs	(revision 14744)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Simplifier/RandomSimplifier.cs	(revision 14745)
@@ -7,16 +7,16 @@
     public int Trys { get; set; }
 
-    public ExecExpandExpression Simplify(ExecExpandExpression program, IRandom random, Predicate<ExecExpandExpression> isBetter) {
+    public PushProgram Simplify(PushProgram program, IRandom random, Predicate<PushProgram> isBetter) {
 
-      if (program.State.TotalCount == 1) {
-        return isBetter(ExecExpandExpression.Empty) ? ExecExpandExpression.Empty : program;
+      if (program.TotalCount == 1) {
+        return isBetter(PushProgram.Empty) ? PushProgram.Empty : program;
       }
 
       var copy = program.Copy();
-      var maxTries = Math.Min(Trys, program.State.TotalCount - 2);
+      var maxTries = Math.Min(Trys, program.TotalCount - 2);
       var successfulRemoves = 0;
 
       for (var i = 0; i < maxTries; i++) {
-        var rndIndex = random.Next(1, program.State.TotalCount - 1 - successfulRemoves);
+        var rndIndex = random.Next(1, program.TotalCount - 1 - successfulRemoves);
         var node = copy.GetFromTree(
           rndIndex,
@@ -28,9 +28,9 @@
           });
 
-        var oldParentExpressions = node.Parent.State.Expressions as Expression[];
+        var oldParentExpressions = node.Parent.State;
         var newParentExpressions = RemoveAt(oldParentExpressions, node.ChildIndex);
-        var newParent = new ExecExpandExpression(newParentExpressions);
+        var newParent = new PushProgram(newParentExpressions);
 
-        var superExpressions = (node.Super == null ? copy.State.Expressions : node.Super.State.Expressions) as Expression[];
+        var superExpressions = node.Super == null ? copy.State : node.Super.State;
         superExpressions[node.ParentIndex] = newParent;
 
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Interpreter/Expressions/StandardTests.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Interpreter/Expressions/StandardTests.cs	(revision 14744)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Interpreter/Expressions/StandardTests.cs	(revision 14745)
@@ -51,5 +51,5 @@
                           };
 
-      var list = new ExecExpandExpression(expressions);
+      var list = new PushProgram(expressions);
       var clone = list.Copy();
 
@@ -68,13 +68,13 @@
                           };
 
-      var list = new ExecExpandExpression(expressions.ToArray());
+      var list = new PushProgram(expressions.ToArray());
 
       expressions.Add(list);
 
-      var list2 = new ExecExpandExpression(expressions.ToArray());
+      var list2 = new PushProgram(expressions.ToArray());
       var clone = list2.Copy();
 
-      Assert.AreSame(list, clone.State.Expressions.Last());
-      Assert.AreEqual(list, clone.State.Expressions.Last());
+      Assert.AreSame(list, clone.State.Last());
+      Assert.AreEqual(list, clone.State.Last());
 
       Assert.AreNotSame(list2, clone);
@@ -92,9 +92,9 @@
                           };
 
-      var list = new ExecExpandExpression(expressions.ToArray());
+      var list = new PushProgram(expressions.ToArray());
 
       expressions.Add(list);
-      var list2 = new ExecExpandExpression(expressions.ToArray());
-      var list3 = new ExecExpandExpression(expressions.ToArray());
+      var list2 = new PushProgram(expressions.ToArray());
+      var list3 = new PushProgram(expressions.ToArray());
 
       Assert.AreEqual(list2.GetHashCode(), list3.GetHashCode());
Index: branches/PushGP/HeuristicLab.PushGP/PushGP.Cli/Program.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/PushGP.Cli/Program.cs	(revision 14744)
+++ branches/PushGP/HeuristicLab.PushGP/PushGP.Cli/Program.cs	(revision 14745)
@@ -107,5 +107,5 @@
     static void PerformanceParallelTestInterpreter() {
       var program = PushParser.Parse("( 5 INTEGER.DUP INTEGER.+ )");
-      //var program = new ExecExpandExpression(new Expression[]
+      //var program = new PushProgram(new Expression[]
       //{
       //  new IntegerPushExpression(5),
@@ -231,5 +231,5 @@
     static void TestSimplifier() {
       var interpreter = new PushInterpreter();
-      var program = PushParser.Parse("( 5 INTEGER.DUP FLOAT.+ INTEGER.+ )") as ExecExpandExpression;
+      var program = PushParser.Parse("( 5 INTEGER.DUP FLOAT.+ INTEGER.+ )") as PushProgram;
       var simplifier = new RandomSimplifier { Trys = 10 };
       var random = new FastRandom(1337);
Index: branches/PushGP/HeuristicLab.PushGP/TestPooling/Pool/IManagedPool.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/TestPooling/Pool/IManagedPool.cs	(revision 14745)
+++ branches/PushGP/HeuristicLab.PushGP/TestPooling/Pool/IManagedPool.cs	(revision 14745)
@@ -0,0 +1,14 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using System.Threading.Tasks;
+
+namespace TestPooling.Pool
+{
+    public interface IManagedPool<T> : IDisposable
+    where T: class
+    {
+      T Get();
+    }
+}
Index: branches/PushGP/HeuristicLab.PushGP/TestPooling/Pool/ManagedPool.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/TestPooling/Pool/ManagedPool.cs	(revision 14744)
+++ branches/PushGP/HeuristicLab.PushGP/TestPooling/Pool/ManagedPool.cs	(revision 14745)
@@ -17,4 +17,6 @@
 
     private int entryIndex = 0;
+
+    public static int InstanceCount { get { return Pool.Sum(p => p.Count); } }
 
     public ManagedPool(int partitionSize, Func<T> factory) {
Index: branches/PushGP/HeuristicLab.PushGP/TestPooling/Pool/ManagedPool2.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/TestPooling/Pool/ManagedPool2.cs	(revision 14744)
+++ branches/PushGP/HeuristicLab.PushGP/TestPooling/Pool/ManagedPool2.cs	(revision 14745)
@@ -1,75 +1,59 @@
-﻿using System.Collections.Generic;
+﻿//using System.Collections.Generic;
 
-namespace TestPooling.Pool {
-  using System;
-  using System.Collections.Concurrent;
-  using System.IO;
-  using System.Linq;
-  using System.Runtime.Serialization.Formatters.Binary;
+//namespace TestPooling.Pool {
+//  using System;
+//  using System.Collections.Concurrent;
+//  using System.IO;
+//  using System.Linq;
+//  using System.Runtime.Serialization.Formatters.Binary;
 
-  public class ManagedPool2<T> : IDisposable where T : class {
+//  public class ManagedPool2<T> : IDisposable where T : class {
 
-    private static readonly ConcurrentStack<T[]> Pool = new ConcurrentStack<T[]>();
+//    private static readonly ConcurrentStack<T[]> Pool = new ConcurrentStack<T[]>();
 
-    private readonly T[] DummyPartition;
-    private readonly Func<T> Factory;
-    public readonly int PartitionSize;
+//    private readonly T[] DummyPartition;
+//    public readonly int PartitionSize;
 
-    private readonly IList<T[]> partitions = new List<T[]>();
-    private T[] currentPartition;
-    private int entryIndex;
+//    private readonly IList<T[]> partitions = new List<T[]>();
+//    private T[] currentPartition;
+//    private int entryIndex;
 
-    public ManagedPool2(int partitionSize, T[] dummyPartition, Func<T> factory) {
-      PartitionSize = partitionSize;
-      Factory = factory;
-      entryIndex = partitionSize;
+//    public ManagedPool2(int partitionSize, T[] dummyPartition) {
+//      PartitionSize = partitionSize;
+//      entryIndex = partitionSize;
 
-      DummyPartition = dummyPartition;
-    }
+//      DummyPartition = dummyPartition;
+//    }
 
-    public T Get() {
-      if (entryIndex == PartitionSize) {
-        currentPartition = GetPartition();
-        partitions.Add(currentPartition);
-        entryIndex = 0;
-      }
+//    public T Get() {
+//      if (entryIndex == PartitionSize) {
+//        currentPartition = GetPartition();
+//        partitions.Add(currentPartition);
+//        entryIndex = 0;
+//      }
 
-      return currentPartition[entryIndex++];
-    }
+//      return currentPartition[entryIndex++];
+//    }
 
-    private T[] GetPartition() {
-      //T[] partition;
+//    private T[] GetPartition() {
+//      T[] partition;
+//      return (Pool.TryPop(out partition)) ? partition : DeepArrayCopy(DummyPartition);
+//    }
 
-      //partition = Pool.TryPop(out partition) ? partition : new T[PartitionSize];
+//    private static T[] DeepArrayCopy(object objectToCopy) {
+//      using (var memoryStream = new MemoryStream()) {
+//        var binaryFormatter = new BinaryFormatter();
 
-      //for (var i = 0; i < PartitionSize; i++) {
-      //  partition[i] = Factory();
-      //}
+//        binaryFormatter.Serialize(memoryStream, objectToCopy);
+//        memoryStream.Seek(0, SeekOrigin.Begin);
 
-      //return partition;
+//        return (T[])binaryFormatter.Deserialize(memoryStream);
+//      }
+//    }
 
-      T[] partition;
-      if (Pool.TryPop(out partition)) return partition;
-
-      //partition = new T[PartitionSize];
-      //DummyPartition.CopyTo(partition, 0);
-
-      return DeepArrayCopy(DummyPartition);
-    }
-
-    private static T[] DeepArrayCopy(object objectToCopy) {
-      using (var memoryStream = new MemoryStream()) {
-        var binaryFormatter = new BinaryFormatter();
-
-        binaryFormatter.Serialize(memoryStream, objectToCopy);
-        memoryStream.Seek(0, SeekOrigin.Begin);
-
-        return (T[])binaryFormatter.Deserialize(memoryStream);
-      }
-    }
-
-    public void Dispose() {
-      Pool.PushRange(partitions.ToArray());
-    }
-  }
-}
+//    public void Dispose() {
+//      Pool.PushRange(partitions.ToArray());
+//      partitions.Clear();
+//    }
+//  }
+//}
Index: branches/PushGP/HeuristicLab.PushGP/TestPooling/Pool/ManagedPoolProvider.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/TestPooling/Pool/ManagedPoolProvider.cs	(revision 14744)
+++ branches/PushGP/HeuristicLab.PushGP/TestPooling/Pool/ManagedPoolProvider.cs	(revision 14745)
@@ -1,45 +1,82 @@
-﻿//using System;
+﻿using System;
 
-//namespace TestPooling.Pool {
-//  using System.Collections.Concurrent;
-//  using System.Threading.Tasks;
+namespace TestPooling.Pool {
+  using System.Collections.Concurrent;
+  using System.Collections.Generic;
+  using System.IO;
+  using System.Linq;
+  using System.Runtime.Serialization.Formatters.Binary;
 
-//  public class ManagedPoolProvider<T> where T : class {
-//    private static readonly volatile ConcurrentStack<T[]> partitions = new ConcurrentStack<T[]>();
-//    private readonly Func<T> Factory;
-//    public readonly int PartitionSize;
+  public class ManagedPoolProvider<T> where T : class {
+    private readonly ConcurrentStack<T[]> partitions = new ConcurrentStack<T[]>();
+    private readonly ObjectPool<IManagedPool<T>> managedPools;
+    private T[] DummyPartition;
+    public readonly int PartitionSize;
 
-//    public ManagedPoolProvider(int partitionSize, Func<T> factory) {
-//      PartitionSize = partitionSize;
-//      Factory = factory;
-//    }
+    public int InstanceCount { get { return partitions.Count * PartitionSize; } }
 
-//    public T[] GetPartition() {
-//      T[] partition;
+    public ManagedPoolProvider(int partitionSize) {
+      PartitionSize = partitionSize;
+      managedPools = new ObjectPool<IManagedPool<T>>(() => new ManagedPool2<T>(this));
+    }
+    public void InitDummyPartition(Func<T> factory) {
+      DummyPartition = new T[PartitionSize];
 
-//      return partitions.TryPop(out partition) ? partition : CreatePartition();
-//    }
+      for (var i = 0; i < PartitionSize; i++) {
+        DummyPartition[i] = factory();
+      }
+    }
 
-//    public void ReleasePartitions(params T[][] partition) {
-//      partitions.PushRange(partition);
-//    }
+    public void ReleasePartitions(params T[][] partition) {
+      if (partition.Length > 0) partitions.PushRange(partition);
+    }
 
-//    public T CreateEntry() {
-//      return Factory();
-//    }
+    private T[] GetPartition() {
+      T[] partition;
+      return partitions.TryPop(out partition) ? partition : DeepArrayCopy(DummyPartition);
+    }
 
-//    private T[] CreatePartition() {
-//      //return new T[PartitionSize];
+    private static T[] DeepArrayCopy(object objectToCopy) {
+      using (var memoryStream = new MemoryStream()) {
+        var binaryFormatter = new BinaryFormatter();
 
-//      var partition = new T[PartitionSize];
+        binaryFormatter.Serialize(memoryStream, objectToCopy);
+        memoryStream.Seek(0, SeekOrigin.Begin);
 
-//      Parallel.For(0, PartitionSize, i => partition[i] = Factory());
+        return (T[])binaryFormatter.Deserialize(memoryStream);
+      }
+    }
 
-//      return partition;
-//    }
+    public IManagedPool<T> CreatePool() {
+      return managedPools.Allocate();
+    }
 
-//    public ManagedPool<T> CreatePool() {
-//      return new ManagedPool<T>(this);
-//    }
-//  }
-//}
+    private class ManagedPool2<T> : IManagedPool<T> where T : class {
+      private readonly ManagedPoolProvider<T> provider;
+      private readonly IList<T[]> partitions = new List<T[]>();
+      private T[] currentPartition;
+      private int entryIndex;
+
+      public ManagedPool2(ManagedPoolProvider<T> provider) {
+        this.provider = provider;
+        entryIndex = provider.PartitionSize;
+      }
+
+      public T Get() {
+        if (entryIndex == provider.PartitionSize) {
+          currentPartition = provider.GetPartition();
+          partitions.Add(currentPartition);
+          entryIndex = 0;
+        }
+
+        return currentPartition[entryIndex++];
+      }
+
+      public void Dispose() {
+        provider.ReleasePartitions(partitions.ToArray());
+        partitions.Clear();
+        provider.managedPools.Free(this);
+      }
+    }
+  }
+}
